/* simple program for BrickOS (version 0.9) that sends an IR message from RCX to WowWee robots */

#include <conio.h>
#include <unistd.h>

#include <lnp/lnp-logical.h>
#include <sys/h8.h>
#include <sys/time.h>

inline void wait_unit()
{
  unsigned char b, c;

  for (b = 0; b < 255; b++)
    for (c = 0; c < 1; c++);
  for (b = 0; b < 25; b++)
    for (c = 0; c < 1; c++);
}

void sapien_send(int code, char version)
{
  int x = (version==(unsigned char)1)?128:2048;

  asm("ORC #128, ccr");  /* clear interrupts */

  /* clear TE and RE bits */
  S_CR = S_CR & 0xCF;

  /* set direction on the P50 (TxD) to out */
  PORT5_DDR = 5;

  /* header */

  PORT5 = 0;
  /* wait 8/1200 sec */
  wait_unit();
  wait_unit();
  wait_unit();
  wait_unit();
  wait_unit();
  wait_unit();
  wait_unit();
  wait_unit();
  PORT5 = 1;

  while (x)
  {
    if (code & x) /* wait 4/1200 sec */
    {
      wait_unit();
      wait_unit();
      wait_unit();
      wait_unit();
    }
    else /* wait 1/1200 sec */
      wait_unit();

    PORT5 = 0;
    /* wait 1/1200 sec */
    wait_unit();
    PORT5 = 1;

    /* move to next bit of the hexcode */
    x >>= 1;
  }

  /* set again TE and RE bits */
  S_CR = S_CR | 0x30;

  asm("ANDC #127, ccr"); /* set interrupts */
}

int main(int argc, char **argv)
{
  systime_set_timeslice(255);
  lnp_logical_range(1);

  sapien_send(0x28e, 2);

  cputs("done ");
  sleep(1);
  cls();

  return 0;
}

